
import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashSet;
import java.util.StringTokenizer;


public class unique 
{
    StringTokenizer st = new StringTokenizer("") ;
    
    BufferedReader input = new BufferedReader(new InputStreamReader(System.in)) ;
    
    int N, M, Q ;
    
    ArrayList<HashSet<Integer> > sets;
    
    int[] numbers   = new int[1000000] ;
    int[] left      = new int[1000000] ;
    int[] right     = new int[1000000] ;
    int[] intervals = new int[2000000] ;
    int[] duplicity = new int[2000000] ;
    
    String nextToken() throws Exception
    {
        while (!st.hasMoreTokens()) st = new StringTokenizer(input.readLine());
        return st.nextToken();
    }
    
    int nextInt() throws Exception
    {
        return Integer.parseInt(nextToken()) ;
    }
    
    boolean insert(int num, int root, int l, int r)
    {
        if (root * 2 > N)
        {
            // Leaf
            if (sets.get(root).contains(num))
            {
                duplicity[root] = num ;
                return true ;
            }
            else
            {
                sets.get(root).add(num) ;
                return false ;
            }
        }
        else
        {
            boolean dupl = false ;
            
            if (num <= intervals[(l + r) / 2])
            {
                dupl = insert(num, root * 2, l, (l + r) / 2) ;                
            }
            else
            {
                dupl = insert(num, root * 2 + 1, (l + r) / 2 + 1, r) ;
            }    
            
            if (dupl)
            {
                duplicity[root] = 1 ;
            }
            
            return dupl ;
        }
    }
    
    int duplicitKey(int root, int l, int r, int queryLeft, int queryRight)
    {
        // l,r - indexy -- [intervals[l], intervals[r]] - interval vrcholu root
        // [ql, qr] - interval v dotazu
        
        if (duplicity[root] == -1)
        {
            // [l, r] neobsahuje podinterval s duplicitou
            return -1 ;
        }
        else
        {
            if (2 * root > N)
            {
                // v listu
                return duplicity[root] ;
            }
            else
            {
                // musime stepit interval [ql, qr]
                
                int middle = intervals[(l + r) / 2]  ;
                
                if (queryLeft > middle)
                {
                    // whole in right
                    return duplicitKey(2 * root + 1, (l + r) / 2 + 1, r, queryLeft, queryRight) ;
                }
                else if (queryRight <= middle)
                {
                    // whole in left
                    return duplicitKey(2 * root, l, (l + r) / 2, queryLeft, queryRight) ;
                }
                else
                {
                    int result = -1 ;
                    
                    result = Math.max(result, duplicitKey(2 * root, l, (l + r) / 2, queryLeft, intervals[(l + r) / 2])) ;
                    result = Math.max(result, duplicitKey(2 * root + 1, (l + r) / 2 + 1, r, intervals[(l + r) / 2 + 1], queryRight)) ;
                    
                    return result ;
                }         
            }
        }
    }
    
    void run() throws Exception
    {
       while (true)
       {
           M = nextInt() ;
           Q = nextInt() ;

	   intervals = new int[2 * Q];
           
           if (M == 0 && Q == 0)
           {
               break ;
           }
           
           for (int i = 0 ; i < M ; i++)
           {
               numbers[i] = nextInt() ;
           }
           
           for (int i = 0 ; i < 2 * Q ; i++)
           {
               intervals[i] = nextInt() ;
           }
           
           Arrays.sort(intervals) ;


           
           N = 1 ;
                   
           for (int i = 1 ; i < 2 * Q ; i++)
           {
               if (intervals[i] != intervals[i - 1])
               {
                   intervals[N++] = intervals[i] ;
               }
           }

           sets = new ArrayList<HashSet<Integer> >(2000000) ;
           for (int i = 0; i < 2000000; i ++){
                sets.add(new HashSet<Integer>());
           }
           
           for (int i = 0 ; i < M ; i++)
           {
               insert(numbers[i], 1, 0, N - 1) ;
           }

           for (HashSet<Integer> set : sets){
	       if (set.size() > 0){	
                 for (Integer i : set){
                     System.out.print(" " + i);
                 }
                 System.out.println();
               }
           }
           
           for (int i = 0 ; i < Q ; i++)
           {
               int dupl = duplicitKey(1, 0, N - 1, left[i], right[i]) ;
               
               if (dupl != -1)
               {
                   System.out.println(dupl) ;
               }
               else
               {
                   System.out.println("OK") ;
               }
           }
           
           System.out.println() ;
       }
    }

    public static void main(String[] args) throws Exception 
    {      
       (new unique()).run() ;
    }
}
